// Proyecto: NetPower
// Autor: Luciano Javier Lagassa <lucianolagassa@gmail.com>
// Web: http://www.lagasystems.com.ar/
// Info: Sistema de Control Remoto por Red Utilizando Telnet, Permite controlar el estado de 8 reles.
// Basado en el Codigo de Telnet - David A. Mellis & Tom Igoe  Modified by Antonius (Sw0rdm4n) 
#include <Ethernet.h>

String Version="0.17.12.27-1920";
boolean Lectura1 = false;
boolean Lectura2 = false;
String Modo = "";
String Data = "";
String Estado1 = "OFF";
String Estado2 = "OFF";
String Estado3 = "OFF";
String Estado4 = "OFF";
String Estado5 = "OFF";
String Estado6 = "OFF";
String Estado7 = "OFF";
String Estado8 = "OFF";
int Salida1 = 2;
int Salida2 = 3;
int Salida3 = 4;
int Salida4 = 5;
int Salida5 = 6;
int Salida6 = 7;
int Salida7 = 8;
int Salida8 = 9;

byte mac[] = { 0x90, 0xA2, 0xDA, 0x0F, 0x17, 0xD9 };
IPAddress ip(192,168,3,83);
IPAddress gateway(192,168,3,1);
IPAddress subnet(255,255,255,0);
EthernetServer server(23);

void setup()
{
  pinMode(Salida1, OUTPUT);
  pinMode(Salida2, OUTPUT);
  pinMode(Salida3, OUTPUT);
  pinMode(Salida4, OUTPUT);
  pinMode(Salida5, OUTPUT);
  pinMode(Salida6, OUTPUT);
  pinMode(Salida7, OUTPUT);
  pinMode(Salida8, OUTPUT);
  Ethernet.begin(mac, ip);
  server.begin();
} 

void loop()
{
  EthernetClient client = server.available();
  if (client)
  {
    int i;
    boolean currentLineIsBlank = true;
    while (client.connected())
    {
      if (client.available() > 0)
      {
        if (Lectura1 == false)
        {
          client.print("\nNetPower v"+Version+" - LAGA Systems\n");
          delay(500);
          client.print("Comando: ");
          Lectura1 = true;
        }
        else
        {
          char Data = client.read();
          if(Lectura2 == false)
          {
            switch (Data)
            {
              case '\n':
                //client.print("Error Camando No Soportado\n");
                Lectura1=false;
                Lectura2=false;
                Modo = "";
                delay(200);
              break;
              case '?':
                client.print("\nAyuda\n");
                client.print(" Lista de Comandos\n");
                client.print("  a? = Activar el Puerto Segun Numero [0-8]\n");
                client.print("  d? = Desactivar el Puerto Segun Numero [0-8]\n");
                client.print("  e? = Estado del Puerto Segun Numero [0-8]\n");
                client.print("  r? = Resetear Puerto Segun Numero [0-8]\n");
                client.print("  s  = Salir\n");
                Lectura1=false;
                Lectura2=false;
                Modo = "";
                delay(200);
              break;
              case 's':
                client.print("Saludos\n");
                client.stop();
                Lectura1=false;
                Lectura2=false;
                Modo = "";
                delay(200);
              break;
              case 'a':
                client.print("Activar Puerto\n");
                client.print("Ingrese Numero [0-8]:");
                Lectura2 = true;
                Modo = "a";
                delay(200);
              break;
              case 'd':
                client.print("Desactivar Puerto\n");
                client.print("Ingrese Numero [0-8]:");
                Lectura2 = true;
                Modo = "d";
                delay(200);
              break;
              case 'r':
                client.print("Resetear Puerto\n");
                client.print("Ingrese Numero [0-8]:");
                Lectura2 = true;
                Modo = "r";
                delay(200);
              break;
              case 'e':
                client.print("Estado Puerto\n");
                client.print("Ingrese Numero [0-8]:");
                Lectura2 = true;
                Modo = "e";
                delay(200);
              break;
            }
          }
          else
          {
            switch (Data)
            {
              
              case '\n':
                //client.print("Error Camando No Soportado\n");
                Lectura1=false;
                Lectura2=false;
                Modo = "";
                delay(200);
              break;
              case '0':
                if(Modo == "a")
                {
                  client.print("\nActivando Todos los Puertos\n");
                  digitalWrite(Salida1, HIGH);
                  digitalWrite(Salida2, HIGH);
                  digitalWrite(Salida3, HIGH);
                  digitalWrite(Salida4, HIGH);
                  digitalWrite(Salida5, HIGH);
                  digitalWrite(Salida6, HIGH);
                  digitalWrite(Salida7, HIGH);
                  digitalWrite(Salida8, HIGH);
                  Estado1 = "ON";
                  Estado2 = "ON";
                  Estado3 = "ON";
                  Estado4 = "ON";
                  Estado5 = "ON";
                  Estado6 = "ON";
                  Estado7 = "ON";
                  Estado8 = "ON";
                }
                if(Modo == "d")
                {
                  client.print("\nDesactivando Todos los Puertos\n");
                  digitalWrite(Salida1, LOW);
                  digitalWrite(Salida2, LOW);
                  digitalWrite(Salida3, LOW);
                  digitalWrite(Salida4, LOW);
                  digitalWrite(Salida5, LOW);
                  digitalWrite(Salida6, LOW);
                  digitalWrite(Salida7, LOW);
                  digitalWrite(Salida8, LOW);
                  Estado1 = "OFF";
                  Estado2 = "OFF";
                  Estado3 = "OFF";
                  Estado4 = "OFF";
                  Estado5 = "OFF";
                  Estado6 = "OFF";
                  Estado7 = "OFF";
                  Estado8 = "OFF";
                }
                if(Modo == "e")
                {
                  client.print("\n");
                  client.print(" Estado del Puerto N:1 "+Estado1+"\n");
                  client.print(" Estado del Puerto N:2 "+Estado1+"\n");
                  client.print(" Estado del Puerto N:3 "+Estado1+"\n");
                  client.print(" Estado del Puerto N:4 "+Estado1+"\n");
                  client.print(" Estado del Puerto N:5 "+Estado1+"\n");
                  client.print(" Estado del Puerto N:6 "+Estado1+"\n");
                  client.print(" Estado del Puerto N:7 "+Estado1+"\n");
                  client.print(" Estado del Puerto N:8 "+Estado1+"\n");
                }
                if(Modo == "r")
                {
                  client.print("\nReseteando Todos los Puertos\n");
                  if (Estado1 == "ON")
                  {
                    client.print("Desactivando Puerto N:1\n");
                    digitalWrite(Salida1, LOW);
                  }
                  if (Estado2 == "ON")
                  {
                    client.print("Desactivando Puerto N:2\n");
                    digitalWrite(Salida2, LOW);
                  }
                  if (Estado3 == "ON")
                  {
                    client.print("Desactivando Puerto N:3\n");
                    digitalWrite(Salida3, LOW);
                  }
                  if (Estado4 == "ON")
                  {
                    client.print("Desactivando Puerto N:4\n");
                    digitalWrite(Salida4, LOW);
                  }
                  if (Estado5 == "ON")
                  {
                    client.print("Desactivando Puerto N:5\n");
                    digitalWrite(Salida5, LOW);
                  }
                  if (Estado6 == "ON")
                  {
                    client.print("Desactivando Puerto N:6\n");
                    digitalWrite(Salida6, LOW);
                  }
                  if (Estado7 == "ON")
                  {
                    client.print("Desactivando Puerto N:7\n");
                    digitalWrite(Salida7, LOW);
                  }
                  if (Estado8 == "ON")
                  {
                    client.print("Desactivando Puerto N:8\n");
                    digitalWrite(Salida8, LOW);
                  }
                  client.print("Esperando 30 Segundos\n");
                  delay(30000);
                  if (Estado1 == "ON")
                  {
                    client.print("Activando Puerto N:1\n");
                    digitalWrite(Salida1, HIGH);
                  }
                  if (Estado2 == "ON")
                  {
                    client.print("Activando Puerto N:2\n");
                    digitalWrite(Salida2, HIGH);
                  }
                  if (Estado3 == "ON")
                  {
                    client.print("Activando Puerto N:3\n");
                    digitalWrite(Salida3, HIGH);
                  }
                  if (Estado4 == "ON")
                  {
                    client.print("Activando Puerto N:4\n");
                    digitalWrite(Salida4, HIGH);
                  }
                  if (Estado5 == "ON")
                  {
                    client.print("Activando Puerto N:5\n");
                    digitalWrite(Salida5, HIGH);
                  }
                  if (Estado6 == "ON")
                  {
                    client.print("Activando Puerto N:6\n");
                    digitalWrite(Salida6, HIGH);
                  }
                  if (Estado7 == "ON")
                  {
                    client.print("Activando Puerto N:7\n");
                    digitalWrite(Salida7, HIGH);
                  }
                  if (Estado8 == "ON")
                  {
                    client.print("Activando Puerto N:8\n");
                    digitalWrite(Salida8, HIGH);
                  }
                }                
                Lectura1=false;
                Lectura2=false;
                Modo = "";
              break;
              case '1':
                if(Modo == "a")
                {
                  client.print("\nActivando Puerto N:1\n");
                  digitalWrite(Salida1, HIGH);
                  Estado1 = "ON";
                }
                if(Modo == "d")
                {
                  client.print("\nDesactivando Puerto N:1\n");
                  digitalWrite(Salida1, LOW);
                  Estado1 = "OFF";
                }
                if(Modo == "e")
                {
                  client.print("\nEstado del Puerto N:1 "+Estado1+"\n");
                }
                Lectura1=false;
                Lectura2=false;
                Modo = "";
              break;
              case '2':
                if(Modo == "a")
                {
                  client.print("\nActivando Puerto N:2\n");
                  digitalWrite(Salida2, HIGH);
                  Estado2 = "ON";
                }
                if(Modo == "d")
                {
                  client.print("\nDesactivando Puerto N:2\n");
                  digitalWrite(Salida2, LOW);
                  Estado2 = "OFF";
                }
                if(Modo == "e")
                {
                  client.print("\nEstado del Puerto N:2 "+Estado2+"\n");
                }
                Lectura1=false;
                Lectura2=false;
                Modo = "";
              break;
              case '3':
                if(Modo == "a")
                {
                  client.print("\nActivando Puerto N:3\n");
                  digitalWrite(Salida3, HIGH);
                  Estado3 = "ON";
                }
                if(Modo == "d")
                {
                  client.print("\nDesactivando Puerto N:3\n");
                  digitalWrite(Salida3, LOW);
                  Estado3 = "OFF";
                }
                if(Modo == "e")
                {
                  client.print("\nEstado del Puerto N:3 "+Estado3+"\n");
                }
                Lectura1=false;
                Lectura2=false;
                Modo = "";
              break;
              case '4':
                if(Modo == "a")
                {
                  client.print("\nActivando Puerto N:4\n");
                  digitalWrite(Salida4, HIGH);
                  Estado4 = "ON";
                }
                if(Modo == "d")
                {
                  client.print("\nDesactivando Puerto N:4\n");
                  digitalWrite(Salida4, LOW);
                  Estado4 = "OFF";
                }
                if(Modo == "e")
                {
                  client.print("\nEstado del Puerto N:4 "+Estado4+"\n");
                }
                Lectura1=false;
                Lectura2=false;
                Modo = "";
              break;
              case '5':
                if(Modo == "a")
                {
                  client.print("\nActivando Puerto N:5\n");
                  digitalWrite(Salida5, HIGH);
                  Estado5 = "ON";
                }
                if(Modo == "d")
                {
                  client.print("\nDesactivando Puerto N:5\n");
                  digitalWrite(Salida5, LOW);
                  Estado5 = "OFF";
                }
                if(Modo == "e")
                {
                  client.print("\nEstado del Puerto N:5 "+Estado5+"\n");
                }
                Lectura1=false;
                Lectura2=false;
                Modo = "";
              break;
              case '6':
                if(Modo == "a")
                {
                  client.print("\nActivando Puerto N:6\n");
                  digitalWrite(Salida6, HIGH);
                  Estado6 = "ON";
                }
                if(Modo == "d")
                {
                  client.print("\nDesactivando Puerto N:6\n");
                  digitalWrite(Salida6, LOW);
                  Estado6 = "OFF";
                }
                if(Modo == "e")
                {
                  client.print("\nEstado del Puerto N:6 "+Estado6+"\n");
                }
                Lectura1=false;
                Lectura2=false;
                Modo = "";
              break;
              case '7':
                if(Modo == "a")
                {
                  client.print("\nActivando Puerto N:7\n");
                  digitalWrite(Salida7, HIGH);
                  Estado7 = "ON";
                }
                if(Modo == "d")
                {
                  client.print("\nDesactivando Puerto N:7\n");
                  digitalWrite(Salida7, LOW);
                  Estado7 = "OFF";
                }
                if(Modo == "e")
                {
                  client.print("\nEstado del Puerto N:7 "+Estado7+"\n");
                }
                Lectura1=false;
                Lectura2=false;
                Modo = "";
              break;
              case '8':
                if(Modo == "a")
                {
                  client.print("\nActivando Puerto N:8\n");
                  digitalWrite(Salida8, HIGH);
                  Estado8 = "ON";
                }
                if(Modo == "d")
                {
                  client.print("\nDesactivando Puerto N:8\n");
                  digitalWrite(Salida8, LOW);
                  Estado8 = "OFF";
                }
                if(Modo == "e")
                {
                  client.print("\nEstado del Puerto N:8 "+Estado8+"\n");
                }
                Lectura1=false;
                Lectura2=false;
                Modo = "";
              break;
            }
          }
        }          
      }
    }
    delay(1);
    client.stop();
  }
}
